<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>README</title>
  <style>
    html {
      color: #1a1a1a;
      background-color: #fdfdfd;
    }
    body {
      margin: 0 auto;
      max-width: 36em;
      padding-left: 50px;
      padding-right: 50px;
      padding-top: 50px;
      padding-bottom: 50px;
      hyphens: auto;
      overflow-wrap: break-word;
      text-rendering: optimizeLegibility;
      font-kerning: normal;
    }
    @media (max-width: 600px) {
      body {
        font-size: 0.9em;
        padding: 12px;
      }
      h1 {
        font-size: 1.8em;
      }
    }
    @media print {
      html {
        background-color: white;
      }
      body {
        background-color: transparent;
        color: black;
        font-size: 12pt;
      }
      p, h2, h3 {
        orphans: 3;
        widows: 3;
      }
      h2, h3, h4 {
        page-break-after: avoid;
      }
    }
    p {
      margin: 1em 0;
    }
    a {
      color: #1a1a1a;
    }
    a:visited {
      color: #1a1a1a;
    }
    img {
      max-width: 100%;
    }
    svg {
      height: auto;
      max-width: 100%;
    }
    h1, h2, h3, h4, h5, h6 {
      margin-top: 1.4em;
    }
    h5, h6 {
      font-size: 1em;
      font-style: italic;
    }
    h6 {
      font-weight: normal;
    }
    ol, ul {
      padding-left: 1.7em;
      margin-top: 1em;
    }
    li > ol, li > ul {
      margin-top: 0;
    }
    blockquote {
      margin: 1em 0 1em 1.7em;
      padding-left: 1em;
      border-left: 2px solid #e6e6e6;
      color: #606060;
    }
    code {
      font-family: Menlo, Monaco, Consolas, 'Lucida Console', monospace;
      font-size: 85%;
      margin: 0;
      hyphens: manual;
    }
    pre {
      margin: 1em 0;
      overflow: auto;
    }
    pre code {
      padding: 0;
      overflow: visible;
      overflow-wrap: normal;
    }
    .sourceCode {
     background-color: transparent;
     overflow: visible;
    }
    hr {
      background-color: #1a1a1a;
      border: none;
      height: 1px;
      margin: 1em 0;
    }
    table {
      margin: 1em 0;
      border-collapse: collapse;
      width: 100%;
      overflow-x: auto;
      display: block;
      font-variant-numeric: lining-nums tabular-nums;
    }
    table caption {
      margin-bottom: 0.75em;
    }
    tbody {
      margin-top: 0.5em;
      border-top: 1px solid #1a1a1a;
      border-bottom: 1px solid #1a1a1a;
    }
    th {
      border-top: 1px solid #1a1a1a;
      padding: 0.25em 0.5em 0.25em 0.5em;
    }
    td {
      padding: 0.125em 0.5em 0.25em 0.5em;
    }
    header {
      margin-bottom: 4em;
      text-align: center;
    }
    #TOC li {
      list-style: none;
    }
    #TOC ul {
      padding-left: 1.3em;
    }
    #TOC > ul {
      padding-left: 0;
    }
    #TOC a:not(:hover) {
      text-decoration: none;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    div.columns{display: flex; gap: min(4vw, 1.5em);}
    div.column{flex: auto; overflow-x: auto;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    /* The extra [class] is a hack that increases specificity enough to
       override a similar rule in reveal.js */
    ul.task-list[class]{list-style: none;}
    ul.task-list li input[type="checkbox"] {
      font-size: inherit;
      width: 0.8em;
      margin: 0 0.8em 0.2em -1.6em;
      vertical-align: middle;
    }
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
</head>
<body>
<header id="title-block-header">
<h1 class="title">README</h1>
</header>
<h1 id="addonsbike9876setsdump">addons/bike9876SetsDump</h1>
<h2 id="dump-non-craftable-eso-sets-to-disk-and-display-results">Dump
non-craftable ESO sets to disk and display results</h2>
<h3 id="preliminary-notes">Preliminary Notes</h3>
<p>In the below, <code>ESOLIVEDIR</code> is defined as follows:</p>
<p>On Windows,</p>
<pre><code>  ESOLIVEDIR=&quot;%UserProfile%\Documents\Elder Scrolls Online\live&quot;</code></pre>
<p>(%UserProfile% is usually
<code>C:\Users\YOUR-WINDOWS-USERNAME</code>).</p>
<p>On Windows using the <a
href="https://learn.microsoft.com/en-us/windows/wsl/install">linux
subsystem on windows</a> (WSL),</p>
<pre><code>  ESOLIVEDIR=&quot;/mnt/c/Users/YOUR-WINDOWS-USERNAME/Documents/Elder Scrolls Online/live&quot;</code></pre>
<p>On debian linux running steam/proton,</p>
<pre><code>  ESOLIVEDIR=&quot;$HOME/.steam/steam/steamapps/compatdata/306130/pfx/drive_c/users/steamuser/My Documents/Elder Scrolls Online/live&quot;</code></pre>
<p>On Arch Linux,</p>
<pre><code>  ESOLIVEDIR=&quot;$HOME/.local/share/Steam/steamapps/compatdata/306130/pfx/drive_c/users/steamuser/My Documents/Elder Scrolls Online/live&quot;</code></pre>
<p>It will be something similar for other linux distributions.</p>
<p>ESO game settings, addons, addon output files are all saved under
<code>ESOLIVEDIR</code>.</p>
<p>Windows and linux use a different separator between path components
(‘\’ on Windows, ‘/’ on linux). I’ll use ‘/’ only below for
simplicity.</p>
<h3 id="introduction">Introduction</h3>
<p>It’s often useful to be able to see what pieces in non-craftable sets
have been unlocked. ESO can of course do this (Collections -&gt; Sets
Items). But I often want to see this information when not logged into
ESO, or I want all the data in a text file, so I can search through it
using an editor.</p>
<p>This addon dumps all the non-craftable set info to disk whenever the
user logs out, quits or runs /reloadui.</p>
<p>An accompanying script turns this dumped data into a plain text table
showing what pieces the user has learned.</p>
<p>It also lists the number of known pieces for each of the Undaunted
Pledge Master coffers (can be helpful eg in deciding who to buy a
Mystery Coffer from).</p>
<h3 id="prerequisites">Prerequisites</h3>
<p>For the addon, the following addons are prerequisites:</p>
<ul>
<li>LibSets</li>
<li>LibZone</li>
</ul>
<p>These are most easily installed with <a
href="https://minion.mmoui.com/">minion</a>.</p>
<p>For the helper script I provide <code>make_set_table.py</code> (see
below for details), the following are prerequisites:</p>
<ul>
<li><p>python3</p></li>
<li><p>python3 packages: tabulate, lupa, wcwidth</p></li>
</ul>
<p>(wcwidth is only needed if your language is Japanese or Chinese, but
there’s no harm in installing it).</p>
<p>These would normally be provided by a linux distribution, eg (for
debian or ubuntu) in <code>python3-PACKAGE</code>, so run</p>
<pre><code>  sudo apt install python3-tabulate python3-lupa python3-wcwidth</code></pre>
<p>Or install with pip3: <code>pip3 install PACKAGE</code> for all the
packages.</p>
<p>If running windows, suggest install the linux subsystem on windows
(WSL). If you install the debian or ubuntu distributions, python3 will
be installed, and you can use the above <code>sudo apt install</code>
command to install the needed python3 packages.</p>
<h3 id="download-and-install">Download and Install</h3>
<p>Download <a
href="https://gitlab.com/bike9876-eso/eso/addons/bike9876SetsDump/-/archive/v1.3.1/bike9876SetsDump-v1.3.1.zip">https://gitlab.com/bike9876-eso/eso/addons/bike9876SetsDump/-/archive/v1.3.1/bike9876SetsDump-v1.3.1.zip</a>.</p>
<p>Unpack the zip file.</p>
<p>The extracted files will look like <a href="#fn1"
class="footnote-ref" id="fnref1"
role="doc-noteref"><sup>1</sup></a>:</p>
<pre><code>    bike9876SetsDump-v1.3.1/
    ├── Addons/
    │   └── bike9876SetsDump/
    │       ├── bike9876SetsDump.lua
    │       ├── ...
    │
    ├── LICENSE
    ├── make_set_table.py
    ├── ...</code></pre>
<p>Directory <code>bike9876SetsDump</code> (under <code>Addons</code>)
is an addon.</p>
<p>Copy or move it to the ESO addons directory
<code>ESOLIVEDIR/AddOns/</code>.</p>
<p>So afterwards, there should be a directory
<code>bike9876SetsDump</code> under the ESO addons directory.</p>
<p>If you install/update the addon while ESO is running, you will need
to logout and login (or run /reloadui) for it to be available within the
game.</p>
<h3 id="usage">Usage</h3>
<p>When you logout or quit ESO (or run /reloadui), this addon will
automatically dump details about your non-craftable sets to
<code>bike9876SetsDump.lua</code> under your ESO SavedVariables
directory <code>ESOLIVEDIR/SavedVariables/</code>.</p>
<p>To make a simple plain text display of your sets:</p>
<p>Change directory to <code>bike9876SetsDump-v1.3.1</code> (the
directory created by extracting <code>bike9876SetsDump-v1.3.1.zip</code>
in <a href="#download-and-install">Download and Install</a>).</p>
<p>Copy <code>bike9876SetsDump.lua</code> from your ESO SavedVariables
directory to here.</p>
<p>Run</p>
<pre><code>  python3 make_set_table.py --server EU &gt; setsDump.txt</code></pre>
<p>or</p>
<pre><code>  python3 make_set_table.py --server NA &gt; setsDump.txt</code></pre>
<p>(depending on whether you use the EU or NA server <a href="#fn2"
class="footnote-ref" id="fnref2"
role="doc-noteref"><sup>2</sup></a>).</p>
<p>This assumes you are running linux (possibly the linux subsystem on
Windows). If you have python running directly on Windows, the command
needed will probably be similar.</p>
<p>Open <code>setsDump.txt</code> in an editor. It contains a set of
tables, one for each non-craftable set, showing which pieces you have
learned in each set (a <code>+</code> indicates you have learned
it).</p>
<p>After this set of tables, it then lists the Undaunted Pledge Masters,
and how many pieces you know from each of their coffers. (The names of
the Pledge Masters and of the Coffers is currently only given in
English.)</p>
<h3 id="notes">Notes</h3>
<p>Knowledge of non-craftable sets is shared across all characters (in a
given server), so only one character needs to have the addon
installed.</p>
<p>The <code>make_set_table.py</code> script has some options. Its usage
is:</p>
<pre><code>  python3 make_set_table.py [--help] [--dumpfile DUMPFILE] [--server SERVER] [--account ACCOUNT] [--setname-maxcolwidth SETNAME-MAXCOLWIDTH] [--ncols NCOLS]</code></pre>
<p>The options are:</p>
<pre><code>  --help</code></pre>
<p>lists the available options for the <code>make_set_table.py</code>
script.</p>
<pre><code>  --dumpfile DUMPFILE</code></pre>
<p>specifies that the file to be read in containing dumped set data is
DUMPFILE (instead of the default <code>bike9876SetsDump.lua</code> in
the current directory).</p>
<pre><code>  --server SERVER</code></pre>
<p>is needed if you have account on more than 1 server (eg both the EU
and NA servers), and if the addon is used for these servers. Then
specify eg <code>--server EU</code> to display the data for accounts on
only the EU server. Specify <code>--server NA</code> for the NA
server.</p>
<pre><code>  --account ACCOUNTNAME</code></pre>
<p>is needed if you have more than 1 account on the server (unlikely,
but possible). Eg <code>--account @bike9876</code> .</p>
<pre><code>  --setname-maxcolwidth SETNAME-MAXCOLWIDTH</code></pre>
<p>changes the max width of the column displaying the set name in
<code>make_set_table.py</code>’s output (default is 9 characters).
Setting it to a large value, eg <code>--setname-maxcolwidth 100</code>
ensures that the set names are not split across lines, which is possibly
useful when searching for a name.</p>
<pre><code>  --ncols NCOLS</code></pre>
<p>sets the max number of columns used in the table for each set.
Default is 9. Setting it to a large value, eg <code>--ncols 100</code>
ensures that the data for each set is on a single row (but some rows
will be very long).</p>
<h3 id="license">License</h3>
<p>This software is released under the MIT License. Please see
LICENSE.</p>
<p><a href="https://エボ猫.コム/">bike9876@エボ猫.コム</a></p>
<section id="footnotes" class="footnotes footnotes-end-of-document"
role="doc-endnotes">
<hr />
<ol>
<li id="fn1"><p>Some zip extractors will create a directory above
<code>bike9876SetsDump-v1.3.1</code>, also called
<code>bike9876SetsDump-v1.3.1</code>.<a href="#fnref1"
class="footnote-back" role="doc-backlink">↩︎</a></p></li>
<li id="fn2"><p>If you only use one server, you don’t need the –server
&lt;server&gt; argument (see <a href="#notes">Notes</a>), but there’s no
harm in specifying it.<a href="#fnref2" class="footnote-back"
role="doc-backlink">↩︎</a></p></li>
</ol>
</section>
</body>
</html>
